shop/Models/Product.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Web.Mvc;
namespace shop.Models
{
    public class Product
    {
        [Key]
        public int id { get; set; }
        
        public int BrandId { get; set; }
        public int GroupId { get; set; }

         [Display(Name ="نام محصول")]
         [Required(ErrorMessage ="مقدار برای {0} وارد نمایید")]
         [MaxLength(50, ErrorMessage ="نباید بیشنر از {1} کاراکتر باشد")]
        public string Name { get; set; }

         [Display(Name ="قیمت واحد")]
        public int price { get; set; }

         [Display(Name ="تصویر شاخص")]
         [MaxLength(100, ErrorMessage ="نباید بیشنر از {1} کاراکتر باشد")]
        public string Img { get; set; }

         [Display(Name ="توضیحات محصول ")]
         [DataType(DataType.MultilineText)]
         [AllowHtml]
        public string Des { get; set; }

         [Display(Name ="تعداد بازدید ")]
        public int seen { get; set; }

         [Display(Name ="موجودی ")]
        public int Mojoodi { get; set; }

         [Display(Name ="عدم نمایش ")]
        public bool NotShow { get; set; }

        [ForeignKey("GroupId")]
        public virtual Group Group { get; set; }

        [ForeignKey("BrandId")]
        public virtual Brand Brand { get; set; }

        public virtual ICollection<Gallery> Gallerys { get; set; }

        public virtual ICollection<ProductFeild> ProductFeilds { get; set; }

    }
}

shop/Areas/Admin/Controllers/ProductsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using shop.Models;

namespace shop.Areas.Admin.Controllers
{
    public class ProductsController : Controller
    {
        private DatabaseContext db = new DatabaseContext();

        // GET: Admin/Products
        public ActionResult Index(string strsearch)
        {
           
            var products = db.products.Include(p => p.Brand).Include(p => p.Group).ToList();
            if (!string.IsNullOrEmpty(strsearch)) {

                products = products.Where(p => p.Name.Contains(strsearch) || p.Group.GroupName.Contains(strsearch) || p.Brand.BrandName.Contains(strsearch) ).ToList();

            }
            return View(products.ToList());
        }

        // GET: Admin/Products/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            return View(product);
        }

        // GET: Admin/Products/Create
        public ActionResult Create()
        {
            ViewBag.BrandId = new SelectList(db.Brands, "Id", "BrandName");
            ViewBag.GroupId = new SelectList(db.Groups, "Id", "GroupName");
            return View();
        }

        // POST: Admin/Products/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "id,BrandId,GroupId,Name,price,Img,Des,seen,Mojoodi,NotShow")] Product product, HttpPostedFileBase file)
        {
            if (ModelState.IsValid)
            {
                if(file != null)
                {
                    Random random = new Random();
                    string imgcode = random.Next(10000, 99999).ToString();
                    file.SaveAs(HttpContext.Server.MapPath("~/images/Product/") +imgcode.ToString() + "-" + file.FileName);
                    product.Img = imgcode.ToString() + "-" + file.FileName;
                }
                db.products.Add(product);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.BrandId = new SelectList(db.Brands, "Id", "BrandName", product.BrandId);
            ViewBag.GroupId = new SelectList(db.Groups, "Id", "GroupName", product.GroupId);
            return View(product);
        }

        // GET: Admin/Products/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Product product = db.products.Find(id);
            if (product == null)
            {
                return HttpNotFound();
            }
            ViewBag.BrandId = new SelectList(db.Brands, "Id", "BrandName", product.BrandId);
            ViewBag.GroupId = new SelectList(db.Groups, "Id", "GroupName", product.GroupId);
            return View(product);
        }

        // POST: Admin/Products/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "id,BrandId,GroupId,Name,price,Img,Des,seen,Mojoodi,NotShow")] Product product, HttpPostedFileBase file)
        {
            if (ModelState.IsValid)
            {
                if (file != null)
                {
                    Random random = new Random();
                    string imgcode = random.Next(10000, 99999).ToString();
                    file.SaveAs(HttpContext.Server.MapPath("~/images/Product/") + imgcode.ToString() + "-" + file.FileName);
                    product.Img = imgcode.ToString() + "-" + file.FileName;
                }
                db.Entry(product).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.BrandId = new SelectList(db.Brands, "Id", "BrandName", product.BrandId);
            ViewBag.GroupId = new SelectList(db.Groups, "Id", "GroupName", product.GroupId);
            return View(product);
        }

        // GET: Admin/Products/Delete/5
        public ActionResult Delete(int? id)
        {
            Product product = db.products.Find(id);
            db.products.Remove(product);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

shop/Areas/Admin/Views/Products/Create.cshtml
@model shop.Models.Product

@{
    ViewBag.Title = "افزودن محصول";
    Layout = "~/Areas/Admin/Views/Shared/_AdminLayout.cshtml";
}

    <div class="card">
        <div class="card-header bg-dark text-white">
            <div class="row">
                <div class="col-6 text-left mt-1">
                    افزودن محصول
                </div>
                <div class="col-6 text-right">
                    @Html.ActionLink("بازگشت", "Index", "", new { @class = "btn btn-danger" }) 
               
                </div>
            </div>
        </div>
        <div class="card-body">
            @using (Html.BeginForm("Create", "Products", FormMethod.Post, new { enctype = "multipart/form-data" }))
            {
                @Html.AntiForgeryToken()

                <div class="form-horizontal">
                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    <div class="form-group">
                        @Html.LabelFor(model => model.BrandId, "انتخاب برند", htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.DropDownList("BrandId", null, htmlAttributes: new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.BrandId, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.GroupId, "انتخاب گروه", htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.DropDownList("GroupId", null, htmlAttributes: new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.GroupId, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.price, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.price, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.price, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Img, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            <input type="file" name="file" />
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Des, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Des, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.Des, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Mojoodi, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Mojoodi, new { htmlAttributes = new { @class = "form-control", @value=0, min=0 } })
                            @Html.ValidationMessageFor(model => model.Mojoodi, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.NotShow, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            <div class="checkbox">
                                @Html.EditorFor(model => model.NotShow)
                                @Html.ValidationMessageFor(model => model.NotShow, "", new { @class = "text-danger" })
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input type="submit" value="ثبت" class="btn btn-success" />
                        </div>
                    </div>
                </div>
            }
        </div>
    </div>






<script src="~/Scripts/jquery-3.4.1.min.js"></script>
<script src="~/Scripts/jquery.validate.min.js"></script>
<script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
@section ckeditorsection {
    <script src="/ckeditor/ckeditor.js"></script>
    <script src="/ckeditor/adapters/jquery.js"></script>

    <script>
        $(function () {
            $('#Des').ckeditor();
        });
    </script>
}

shop/Areas/Admin/Views/Products/Details.cshtml
@model shop.Models.Product

@{
    ViewBag.Title = "جزئیات @Model.Name";
    Layout = "~/Areas/Admin/Views/Shared/_AdminLayout.cshtml";
}

    <div class="card">
        <div class="card-header bg-dark text-white">
            <div class="row">
                <div class="col-6 text-left mt-1">
                    جزئیات @Model.Name
                </div>
                <div class="col-6 text-right">
                    @Html.ActionLink("بازگشت", "Index", "", new { @class = "btn btn-danger" })
                </div>
            </div>
        </div>
        <div class="card-body">
            <div>

                <dl class="dl-horizontal">
                    <dt>
                        @Html.DisplayNameFor(model => model.Brand.BrandName)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.Brand.BrandName)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.Group.GroupName)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.Group.GroupName)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.Name)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.Name)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.price)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.price)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.Img)
                    </dt>

                    <dd>
                        <img src="~/images/Product/@Model.Img" alt="@Model.Name" width="150" height="150" />
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.Des)
                    </dt>

                    <dd>
                        @Html.Raw(Model.Des)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.seen)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.seen)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.Mojoodi)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.Mojoodi)
                    </dd>

                    <dt>
                        @Html.DisplayNameFor(model => model.NotShow)
                    </dt>

                    <dd>
                        @Html.DisplayFor(model => model.NotShow)
                    </dd>

                </dl>
            </div>
        </div>
    </div>

shop/Areas/Admin/Views/Products/Edit.cshtml
@model shop.Models.Product

@{
    ViewBag.Title = "     ویرایش @Model.Name";
    Layout = "~/Areas/Admin/Views/Shared/_AdminLayout.cshtml";
}

    <div class="card">
        <div class="card-header bg-dark text-white">
            <div class="row">
                <div class="col-6 text-left mt-1">
                    ویرایش @Model.Name
                </div>
                <div class="col-6 text-right">
                    @Html.ActionLink("بازگشت", "Index", "", new { @class= "btn btn-danger"})
                </div>
            </div>
        </div>
        <div class="card-body">
            @using (Html.BeginForm("Edit", "Products", FormMethod.Post, new { enctype = "multipart/form-data" }))
            {
                @Html.AntiForgeryToken()

                <div class="form-horizontal">

                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    @Html.HiddenFor(model => model.id)
                    @Html.HiddenFor(model => model.Img)
                    <div class="form-group">
                        @Html.LabelFor(model => model.BrandId, "انتخاب برند", htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.DropDownList("BrandId", null, htmlAttributes: new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.BrandId, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.GroupId, "انتخاب گروه", htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.DropDownList("GroupId", null, htmlAttributes: new { @class = "form-control" })
                            @Html.ValidationMessageFor(model => model.GroupId, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.price, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.price, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.price, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Img, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            <input type="file" name="file" />
                            <img src="~/images/Product/@Model.Img" alt="@Model.Name" width="150" height="150" />
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.Des, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Des, new { htmlAttributes = new { @class = "form-control" } })
                            @Html.ValidationMessageFor(model => model.Des, "", new { @class = "text-danger" })
                        </div>
                    </div>

                  
                    <div class="form-group">
                        @Html.LabelFor(model => model.Mojoodi, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            @Html.EditorFor(model => model.Mojoodi, new { htmlAttributes = new { @class = "form-control" }, min=0 })
                            @Html.ValidationMessageFor(model => model.Mojoodi, "", new { @class = "text-danger" })
                        </div>
                    </div>

                    <div class="form-group">
                        @Html.LabelFor(model => model.NotShow, htmlAttributes: new { @class = "control-label col-md-2" })
                        <div class="col-md-10">
                            <div class="checkbox">
                                @Html.EditorFor(model => model.NotShow)
                                @Html.ValidationMessageFor(model => model.NotShow, "", new { @class = "text-danger" })
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input type="submit" value="ویرایش" class="btn btn-success" />
                        </div>
                    </div>
                </div>
            }

        </div>
    </div>




<script src="~/Scripts/jquery-3.4.1.min.js"></script>
<script src="~/Scripts/jquery.validate.min.js"></script>
<script src="~/Scripts/jquery.validate.unobtrusive.min.js"></script>
@section ckeditorsection {
    <script src="/ckeditor/ckeditor.js"></script>
    <script src="/ckeditor/adapters/jquery.js"></script>

    <script>
        $(function () {
            $('#Des').ckeditor();
        });
    </script>
}

shop/Areas/Admin/Views/Products/Index.cshtml
@model IEnumerable<shop.Models.Product>

@{
    ViewBag.Title = "محصولات";
    Layout = "~/Areas/Admin/Views/Shared/_AdminLayout.cshtml";
}

<div class="card">
    <div class="card-header bg-dark text-white">
        <div class="row">
            <div class="col-4 text-left mt-1">
                محصولات
            </div>
            <div class="col-4 text-center">

                @using (Html.BeginForm())
                {
                    <div class="form-inline">
                        <div class="form-group">
                            @Html.TextBox("strsearch", "", new { @class = "form-control border-rad", @placeholder = " کاربر را جسجتو نمایید" })
                        </div>
                        <button type="submit" class="btn btn-primary ml-1 border-rad">
                            <i class="fas fa-search text-light fa-lg"></i>
                        </button>
                    </div>
                }



            </div>
            <div class="col-4 text-right">
                @Html.ActionLink("افزودن", "Create", "", new { @class = "btn btn-success" })
            </div>
        </div>
    </div>
    <div class="card-body">
        <table class="table table-hover">
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.Brand.BrandName)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Group.GroupName)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Name)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.price)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.seen)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.Mojoodi)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.NotShow)
                </th>
                <th>عملیات</th>
            </tr>

            @foreach (var item in Model)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.Brand.BrandName)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Group.GroupName)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Name)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.price)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.seen)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Mojoodi)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.NotShow)
                    </td>
                    <td>
                        @Html.ActionLink("مشخصات", "Index", "ProductFeilds", new { id = item.id }, new { @class = "btn btn-sm btn-outline-success" })
                        @Html.ActionLink("گالری", "Index", "Galleries", new { id = item.id }, new { @class = "btn btn-sm btn-outline-primary" }) 
                        @Html.ActionLink("ویرایش", "Edit", new { id = item.id }, new { @class = "btn btn-sm btn-outline-warning" }) 
                        @Html.ActionLink("جزئیات", "Details", new { id = item.id }, new { @class = "btn btn-sm btn-outline-info" }) 
                        @Html.ActionLink("حذف", "Delete", new { id = item.id }, new { @class = "btn btn-sm btn-outline-danger" })
                    </td>
                </tr>
            }

        </table>
    </div>
</div>